package com.fjhx.victoriatourist.service.jd.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.victoriatourist.entity.jd.dto.JdInfoDto;
import com.fjhx.victoriatourist.entity.jd.dto.JdInfoSelectDto;
import com.fjhx.victoriatourist.entity.jd.po.JdInfo;
import com.fjhx.victoriatourist.entity.jd.vo.JdInfoVo;
import com.fjhx.victoriatourist.mapper.jd.JdInfoMapper;
import com.fjhx.victoriatourist.service.jd.JdInfoService;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 京东基本信息表 服务实现类
 * </p>
 *
 * @author 
 * @since 2023-12-09
 */
@Service
public class JdInfoServiceImpl extends ServiceImpl<JdInfoMapper, JdInfo> implements JdInfoService {

    @Override
    public List<JdInfoVo> getList(JdInfoSelectDto dto) {
        IWrapper<JdInfo> wrapper = getWrapper();
        wrapper.orderByDesc("ji", JdInfo::getId);
        List<JdInfoVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public Page<JdInfoVo> getPage(JdInfoSelectDto dto) {
        IWrapper<JdInfo> wrapper = getWrapper();
        wrapper.orderByDesc("ji", JdInfo::getId);
        Page<JdInfoVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public JdInfoVo detail(Long id) {
        JdInfo JdInfo = this.getById(id);
        JdInfoVo result = BeanUtil.toBean(JdInfo, JdInfoVo.class);
        return result;
    }

    @Override
    public void add(JdInfoDto jdInfoDto) {
        this.save(jdInfoDto);
    }

    @Override
    public void edit(JdInfoDto jdInfoDto) {
        this.updateById(jdInfoDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

    @Override
    public JdInfoVo getOne() {
        List<JdInfoVo> list = getList(new JdInfoSelectDto());
        if (CollectionUtil.isNotEmpty(list)){
            return list.get(0);
        }
        return new JdInfoVo();
    }

    @Override
    public void addOrUpdate(JdInfoDto jdInfoDto) {
        this.saveOrUpdate(jdInfoDto);
    }
}
